//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TEQStart *EQStart;
//---------------------------------------------------------------------------
__fastcall TEQStart::TEQStart(TComponent* Owner)
        : TForm(Owner)
{
        int cpu;

        TIniFile *ini;

        ini = new TIniFile(ChangeFileExt(Application->ExeName, ".INI"));
        Path->Text = ini->ReadString("Files", "Path", "C:\\Program Files\\Sony\EverQuestJ\\EverQuest.exe");
        Workdir->Text = ini->ReadString("Files", "Workdir", "C:\\Program Files\\Sony\EverQuestJ");
        ExitSw->Checked = ini->ReadBool("Exec", "Select", true);
        cpu = ini->ReadInteger("CPU", "Select", 0);

        cpu0->Checked = false;
        cpu1->Checked = false;
        cpu2->Checked = false;
        cpu3->Checked = false;

        if (cpu == 0) {
                cpu0->Checked = true;
        } else if (cpu == 1) {
                cpu1->Checked = true;
        } else if (cpu == 2) {
                cpu2->Checked = true;
        } else if (cpu == 3) {
                cpu3->Checked = true;
        }

        delete ini;
}
//---------------------------------------------------------------------------
void __fastcall TEQStart::Button1Click(TObject *Sender)
{
        char buf[MAX_PATH];

        if (OpenDialog1->Execute()) {
                Path->Text = OpenDialog1->FileName;
                GetCurrentDirectory(MAX_PATH, buf);
                Workdir->Text = buf;
        };
}
//---------------------------------------------------------------------------
void __fastcall TEQStart::Button3Click(TObject *Sender)
{
        EQStart->Close();
}
//---------------------------------------------------------------------------
void __fastcall TEQStart::Button2Click(TObject *Sender)
{
        DWORD ProcessAffinityMask;
        DWORD SystemAffinityMask;
        DWORD errnum;
        STARTUPINFO si;
        PROCESS_INFORMATION pi;

        ZeroMemory(&si, sizeof(si));
        ZeroMemory(&pi, sizeof(pi));
        si.cb = sizeof(si);

        SetCurrentDirectory(Workdir->Text.c_str());

        CreateProcess(NULL, Path->Text.c_str(), NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi);

        ProcessAffinityMask  = 1;

        if (cpu0->Checked == true) {
                ProcessAffinityMask  = 1;
        } else if (cpu1->Checked == true) {
                ProcessAffinityMask  = 2;
        } else if (cpu2->Checked == true) {
                ProcessAffinityMask  = 4;
        } else if (cpu3->Checked == true) {
                ProcessAffinityMask  = 8;
        }

        BOOL ret = SetProcessAffinityMask(pi.hProcess, ProcessAffinityMask);
        if (ret == 0){
                errnum = GetLastError();
        }

        if (ExitSw->Checked == true) {
                EQStart->Close();
        }
}
//---------------------------------------------------------------------------
void __fastcall TEQStart::FormCreate(TObject *Sender)
{
        SYSTEM_INFO sysi;

	GetSystemInfo(&sysi);

        if (sysi.dwNumberOfProcessors > 1) {
                cpu1->Enabled = true;
        }

        if (sysi.dwNumberOfProcessors > 2) {
                cpu2->Enabled = true;
        }

        if (sysi.dwNumberOfProcessors > 3) {
                cpu3->Enabled = true;
        }
}
//---------------------------------------------------------------------------
void __fastcall TEQStart::FormClose(TObject *Sender, TCloseAction &Action)
{
        int cpu;

        TIniFile *ini;

        if (cpu0->Checked == true) {
                cpu = 0;
        } else if (cpu1->Checked == true) {
                cpu = 1;
        } else if (cpu2->Checked == true) {
                cpu = 2;
        } else if (cpu3->Checked == true) {
                cpu = 3;
        }

        ini = new TIniFile(ChangeFileExt(Application->ExeName, ".INI"));
        ini->WriteString("Files", "Path", Path->Text);
        ini->WriteString("Files", "Workdir", Workdir->Text);
        ini->WriteBool("Exec", "Select", ExitSw->Checked);
        ini->WriteInteger("CPU", "Select", cpu);

        delete ini;
}
//---------------------------------------------------------------------------

